do
	local GetSpellCooldown = _G.GetSpellCooldown
	local outputFmt = "%s: %.3f"
	local print = _G.print
	local useGCD = true
	
	local function SpellCastSucceeded(event, unit, spellName, rank, lineId, spellId)
		if unit == "player" and spellName then
			--local start, duration, enabled = GetSpellCooldown(spellId)
			local start, duration, enabled = GetSpellCooldown(useGCD and 61304 or spellId)
			if duration then
				print(outputFmt:format(spellName, duration))
			end
		end
	end

	local function EventFrame_OnEvent(frame, event, ...)
		if event == "UNIT_SPELLCAST_SUCCEEDED" then
			SpellCastSucceeded(event, ...)
		elseif event == "ADDON_LOADED" then
			local addonName = ...
			if addonName == "ShowGCD" then
				ShowGCDDB = ShowGCDDB or {
					enabled = true,
					useGCD = true				
				}
				useGCD = ShowGCDDB.useGCD
				if ShowGCDDB.enabled then
					frame:RegisterUnitEvent("UNIT_SPELLCAST_SUCCEEDED", "player")
				end
			end			
		end
	end

	local frame = _G.CreateFrame("Frame", "ShowGCD_EventFrame")
	frame:SetScript("OnEvent", EventFrame_OnEvent)
	frame:RegisterEvent("ADDON_LOADED")
	
	SlashCmdList["SHOWGCD_SLASHCMD"] = function(input, editBox)
		if input == "off" then
			ShowGCDDB.enabled = false
			frame:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
			print("ShowGCD: Disabled.")
		elseif input == "on" then
			ShowGCDDB.enabled = true
			frame:RegisterUnitEvent("UNIT_SPELLCAST_SUCCEEDED", "player")
			print("ShowGCD: Enabled.")
		elseif input == "gcd" then
			useGCD = true
			ShowGCDDB.useGCD = useGCD 
			print("ShowGCD: Using the GCD spell.")
		elseif input == "cast" then
			useGCD = false
			ShowGCDDB.useGCD = useGCD
			print("ShowGCD: Using the cast spell.")
		elseif input == "" then
			print("Usage: /showgcd [off,on,gcd,cast]")
		end
	end
	SLASH_SHOWGCD_SLASHCMD1 = '/showgcd'
end
